/* *****************************************************************
 *
 *  $Id: f0m_xdr.h,v 1.1 2002/09/27 12:43:02 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/09/16 19:22:19 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __F1_XDR_H
#define __F1_XDR_H

#include "glob.h"
#include "f0s_tkout.h"
#include "f0m_tkin.h"

/* For JML variant of XDR */
#include "f0m_x_2_jml.h"
#include "f0m_jml_2_x.h"

/* For XML variant of XDR */
#include "f0m_x_2_xml.h"
#include "f0m_xml_2_x.h"


__BEGIN_DECLS

typedef enum xdr_protocol_e xdr_protocol_t;
enum xdr_protocol_e {
	XDR_UNDEF,
	XDR_JML,
	XDR_XML
};


enum {
	TKIN_2_XDR = 0,
	TKOUT_2_XDR,
	XDR_2_TKIN,
	XDR_2_TKOUT,
	XDR_LAST
};

typedef void *(*f0m_xdr_f)(const void *);

extern f0m_xdr_f f0m_xdr[XDR_LAST];


#define f0m_tkin_2_xdr(tkin)	f0m_xdr[TKIN_2_XDR](tkin)
#define f0m_tkout_2_xdr(tkout)	f0m_xdr[TKOUT_2_XDR](tkout)
#define f0m_xdr_2_tkin(tkin)	f0m_xdr[XDR_2_TKIN](tkin)
#define f0m_xdr_2_tkout(tkout)	f0m_xdr[XDR_2_TKOUT](tkout)


/* -----------------------------------------------------------------
 * Function:    int f0m_init_xdr ()
 *
 * Description: Initialize the XDR protocol to use (JML || XML)
 *
 * Returns:     []
 */
xdr_protocol_t f0m_init_xdr (xdr_protocol_t protocol);


__END_DECLS

#endif /* __F1_XDR_H */
