/* *****************************************************************
 *
 *  $Id: f0s_out_codes.h,v 1.5 2002/09/27 12:43:02 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/09/26 11:35:51 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __F0_OUT_CODES_H
#define __F0_OUT_CODES_H

#define ERROR_SIZE    E_LAST
#define REPLY_SIZE    R_LAST - (R_FIRST+1)
#define OOB_SIZE      O_LAST - (O_FIRST+1)
#define POSITION_SIZE P_LAST - (P_FIRST+1)

/* #################################################################
 *		GENERIC Codes
 * ################################################################# */
/* start_CODE */
typedef enum code_e {
	FIDDLE_OK = 0,
	/* Success */
	E_RTS_OK = FIDDLE_OK,
/* 	O_NO_REGEX, */

/* #################################################################
 *		ERROR Codes
 * ################################################################# */
	/* Errors generated by the 'f0' run-time system */
	E_RTS_SEND_RECEIVE,
	E_RTS_INVALID_TP_PID,
	E_RTS_INVALID_ND_PID,
	E_RTS_NO_CLD_AVAILABLE,
	E_RTS_COMMAND_GENERATION,
	E_RTS_INVALID_TID,
	E_RTS_STAT_FILE,
	E_RTS_FILE_PERM,
	E_RTS_STAT_TTY,
	E_RTS_TTY_PERM,
	E_RTS_ONE_LINE_FUNCTION,
	E_RTS_NO_COMMAND,
	E_RTS_ASTR_CREATE,
	E_RTS_INIT_REGEX,
	E_RTS_INVALID_LINE_NUMBER,
	E_RTS_INVALID_ARGUMENT,
	E_RTS_INVALID_OPTION,
	E_RTS_MEMORY_ERROR,
	E_RTS_INVALID_SIGNUM,
	E_RTS_SIGNAL,
	E_RTS_INVALID_REQID,
	E_RTS_CANNOT_START_DAEMON,
	E_RTS_UNKNOWN_OUTPUT,
	/* Errors generated by parsing the output */
	E_UNKNOWN_CMD_CODE,
	E_TOP,
	E_NOT_RUN,
	E_NO_FRAME_SELECTED,
	E_NO_PROCESS,
	E_NOT_PERMITTED,
	E_NO_SYMBOL,
	E_BOTTOM,
	E_INVALID_EXPRESSION,
	E_NO_SYMBOLS,
	E_NO_SYMBOL_TABLE,
	E_NO_DEF_SOURCE_FILE,
	E_INVALID_BPID,
    E_INVALID_LINE_NUMBER,
    E_FUNCTION_NOT_DEFINED,
    E_LINE_OUT_OF_RANGE,
	E_NO_BOUNDS,
	E_INVALID_SYMBOL,
	E_INVALID_DISPLAY_NUMBER,
	E_NO_DISPLAY_EXPRESSION,
	E_INVALID_ARITHMETIC_OPERATION,
	E_PARSE_ERROR,
	E_TOO_FEW_ARGS,
	E_NO_STACK,
	E_NO_BREAK_OR_WATCH,
	E_NO_LINE_NUM_INFO,
	E_JUNK_AT_END_OF_LINE,
	E_INVALID_THREAD_ID,
	E_NO_THREAD_ID,
	E_NO_THREAD_COMMAND,
	E_SIGSEGV,
	E_LAST,

/* #################################################################
 *		REPLY Codes
 * ################################################################# */
        R_FIRST,
        R_ATTACH,
	R_BREAK,
	R_BREAK_NO_SOURCE,
	R_CALL_VOID,
	R_CONTINUE,
	R_DELETE,
	R_DETACH,
	R_EVALUATE,
	R_INFO_LOCALS,
	R_FILE,
	R_FINISH,
	R_INFO_BREAK,
	R_INFO_BREAK_WATCH_DATA,
	R_INFO_DISPLAY,
	R_INFO_LINE,
	R_INFO_LINE_NO_CODE,
	R_INFO_PROGRAM,
	R_INFO_STACK,
	R_INFO_THREADS,
	R_INFO_WATCHPOINT,
	R_KILL,
	R_LIST,
	R_NEXT,
	R_RUN,
	R_SENDTO,
	R_SET_VARIABLE,
	R_STEP,
	R_SYMBOL_FILE,
	R_THREAD,
	R_TIDS,
	R_ADD_DEBUGGER,
	R_TTY,
	R_UNDISPLAY,
	R_NEW_THREAD,				/* For line processing */
	R_CALL,						/* Not used! */
	R_EVALUATE_ONE_LINE,		/* For internal use */
	R_EVALUATE_MANY_START,		/* For internal use */
	R_EVALUATE_MANY_MIDDLE,		/* For internal use */
	R_EVALUATE_MANY_END,		/* For internal use */
	R_INFO_LOCALS_ONE_LINE,		/* For internal use */
	R_INFO_LOCALS_MANY_START,	/* For internal use */
	R_INFO_LOCALS_MANY_MIDDLE,	/* For internal use */
	R_INFO_LOCALS_MANY_END,		/* For internal use */
	R_DISPLAY_EXPRESSION,		/* For internal use */
	R_DISPLAY_ONE_LINE,			/* For internal use */
	R_DISPLAY_MANY_START,		/* For internal use */
	R_DISPLAY_MANY_MIDDLE,		/* For internal use */
	R_DISPLAY_MANY_END,			/* For internal use */
	R_CLIENTS,					/* Used just in level f2m */
	R_REGISTER_CLIENT,			/* Used just in level f2m */
        R_LAST,
     
/* #################################################################
 *		POSITION Codes
 * ################################################################# */
        P_FIRST,
        P_POSITION,
        P_LAST,

/* #################################################################
 *		OUT OF BAND Codes
 * ################################################################# */
        O_FIRST,
        O_DISPLAY,
	O_BPHIT,
	O_SIGNAL,
	O_NEW_THREAD,
	O_SWITCH_TO_THREAD,
        O_LAST,
} code_t;
/* end_CODE */


#endif /* __F0_OUT_CODES_H */
