/* *****************************************************************
 *
 *  $Id: f1m_back_end.h,v 1.1.1.1 2002/04/28 22:06:53 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <00/10/27 11:35:31 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __F1_BACK_END_H
#define __F1_BACK_END_H

/* *****************************************************************
 *
 *  $Id: f1m_back_end.h,v 1.1.1.1 2002/04/28 22:06:53 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <99/06/24 19:28:26 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description: Implementation of the back-end of the services
 *				 provided by FIDDLE-1.
 *
 *		f1m_be_initialize ()	-- Initialize FIDDLE-1
 *		f1m_be_terminate ()		-- Terminate FIDDLE-1
 *		f1m_be_is_valid_tid ()	-- Check a given TID is valid
 *
 * -----------------------------------------------------------------
 */

#include <stdlib.h>
#include <assert.h>
#include <pthread.h>
#include "glob.h"
#include "chain.h"


__BEGIN_DECLS

/* #################################################################
 *		PUBLIC functions
 * ################################################################# */
 
/* -----------------------------------------------------------------
 * Function:    int status = f1m_be_initialize (void)
 *
 * Description: Start the system thread
 *
 * Returns:     The status
 */
int f1m_be_initialize (void);


/* -----------------------------------------------------------------
 * Function:    int status = f1m_be_terminate (int dummy)
 *
 * Description: Terminate the system thread
 *
 * Returns:     The status
 */
#define f1m_be_terminate() f1m_be_terminate_1 (0)
int f1m_be_terminate_1 (int dummy);


/* -----------------------------------------------------------------
 * Function:    int status = f1m_be_is_valid_tid (int tid)
 *
 * Description: Checkif a given TID is valid
 *
 * Returns:     TRUE if the tid is valid
 */
int f1m_be_is_valid_tid (int tid);

__END_DECLS

#endif /* __F1_BACK_END_H */
