/* *****************************************************************
 *
 *  $Id: f2m_back_end.h,v 1.1.1.1 2002/04/28 22:06:57 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <00/11/06 13:13:41 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description: Implementation of the back-end of the services
 *				 provided by FIDDLE-1.
 *
 *		f1m_be_initialize ()	-- Initialize FIDDLE-1
 *		f1m_be_terminate ()		-- Terminate FIDDLE-1
 *		f1m_be_is_valid_tid ()	-- Check a given TID is valid
 *
 * -----------------------------------------------------------------
 */
#ifndef __F1_BACK_END_H
#define __F1_BACK_END_H


#include "glob.h"
#include "chain.h"
#include <stdlib.h>
#include <assert.h>
#include <pthread.h>


__BEGIN_DECLS

/* #################################################################
 *		PUBLIC functions
 * ################################################################# */


/* -----------------------------------------------------------------
 * Function:    int status = f2m_be_initialize (const char *machine,
 *												const char *service,
 *												int flags)
 *
 * Description: Start the system thread
 *
 * Returns:     The status
 */
PUBLIC int f2m_be_initialize (const char *machine,
							  const char *service, int flags); 


/* -----------------------------------------------------------------
 * Function:    int status = f1m_be_terminate (int halt)
 *
 * Description: Terminate the system thread
 *
 * Returns:     The status
 */
int f1m_be_terminate (int halt);


__END_DECLS

#endif /* __F1_BACK_END_H */
