/* ******************************************************************
 *
 *  $Id: Data_j.java,v 1.1 2002/08/31 15:23:00 rja Exp $
 *
 *  Copyright (c) 2000 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/08/22 15:08:08 rja>
 *
 *  Ricardo Anastacio [jml] <rja@asc.di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * Class Data_j is the result of the abstraction and conjuntion of C's
 * data types repdata_t, posdata_t and errdata_t.
 *
 * -----------------------------------------------------------------
 */

package unl.fct.di.fiddle_j;

import unl.fct.di.fiddle_j.util.*;

public class Data_j {

	 public String str;
	 public Code_j code;
	 public Chain_j data;
	 
	 public Data_j() {
		  super();
		  str = new String();
		  code = new Code_j(Code_j.FIDDLE_OK);
		  data = new Chain_j();
	 }
	

	 public Data_j(String s, Code_j c, Chain_j d) {
		  super();
		  str = new String(s);
		  code = new Code_j(c);
		  data = new Chain_j(d);
	 }
	 
	 public Data_j(Data_j d) {
		  super();
		  str = new String(d.str);
		  code = new Code_j(d.code);
		  data = new Chain_j(d.data);
	 }

	 public String toString() {
		  StringBuffer aux = new StringBuffer();
		  
		  aux.append("Data_j object contents:\n\tstr:").append(str);
		  aux.append("\n\tcode:").append(code.toString());
		  aux.append("\tdata:").append(data.toString());
		  aux.append("\n");

		  return new String(aux);
	 }

}
