/* *****************************************************************
 *
 *  $Id: do_err.h,v 1.1 2002/08/31 15:23:00 rja Exp $
 *
 *  Copyright (c) 2001 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/08/13 17:38:32 rja>
 *
 *  Ricardo Anastacio [jml] <rja@asc.di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *  
 * -----------------------------------------------------------------
 *
 *  Description:
 *    A set of functions to process the err structure and build its
 * JAVA image. Note, this is assuming the err structure is != NULL.
 * -----------------------------------------------------------------
 */
#ifndef __DO_ERR_H_
#define __DO_ERR_H_

#include "common.h"

/*
 * Processes de err C structure in the tkout_t
 * structure, parseing it and constructing a
 * TkoutException to be thrown.
 * (+) env, the JAVA enviroment variable;
 * (+) errMsg, the message to pass to the Exception constructor;
 * (+) tk, the tkout_t structure to process;
 * (-) a TkoutException to throw.
 */
PUBLIC jthrowable do_err(JNIEnv *env, tkout_t *tk);

/*
 * Processes the status field of the tkout_t
 * structure and constructs with it a
 * TkoutException to be thrown.
 * (+) env, the JAVA enviroment variable;
 * (+) errMsg, the message to pass to the Exception constructor;
 * (+) tk, the tkout_t structure to process;
 * (-) a TkoutException to throw.
 */
PUBLIC jthrowable do_status(JNIEnv *env, tkout_t *tk);

#endif /* __DO_ERR_H_ */
