#!/bin/sh

# This script is to call upon compilation.
# It will dinamically write a Code_j class based upon 
# the f0s_out_codes.h file.

FIDDLE_DIR=/opt/fiddle-source/src/f0s/lib
CODES_FILE=f0s_out_codes.h

# STEP 1 - Take the codes out and remove leading spaces.
gawk -f do_outCodes_step1.awk ${FIDDLE_DIR}/${CODES_FILE} > t1.txt

# STEP 2 - Put headers, comments and line starts
gawk -F , -f do_outCodes_step2.awk t1.txt > t2.txt
gawk -F , -f do_outCodes_step3.awk t1.txt >> t2.txt
gawk -F , -f do_outCodes_step4.awk t1.txt >> t2.txt

# STEP 3 - Count variables and fill values
gawk -f do_outCodes_step5.awk t2.txt > t3.txt
gawk -F , -f do_outCodes_step6.awk t1.txt >> t3.txt

# STEP 4 - Finalize
mv t3.txt Code_j.java
\rm t1.txt t2.txt
